<script lang="ts">
import { Component, Prop } from 'vue-property-decorator';
import type { ScrollTo } from '@/logic/ScrollActions';
import type { Emitter } from '@/components/canvas/canvas-events';
import type {
  Onset, Pixel, Point, Unit,
} from '@/data';
import type SharedActions from '@/logic/SharedActions';
import type { BCursorMoveRegisterer } from '../player/BCanvasCursor.vue';
import LabelBehavior from '../LabelBehavior.vue';

@Component
export default class BScrollSelectedOnKey extends LabelBehavior<Emitter, BCursorMoveRegisterer> {
  @Prop()
  scrollTo!: ScrollTo;

  @Prop()
  actions!: SharedActions;

  @Prop()
  pixelUnit!: Unit<Pixel>;

  onKey(e: KeyboardEvent) {
    if (e.key === '.') {
      const label = this.actions.getSelected();
      if (label) {
        this.scrollTo({
          x: this.pixelUnit.fromOnset(label.onset - 5 as Onset).value,
          y: 0,
        } as Point);
      }
    }
  }

  mounted() {
    this.register('document-keydown', this.onKey);
    this.register('document-shift-keydown', this.onKey);
  }
}
</script>
